/* 
 --------------------------
 ** PLEASE READ INFO TAB **
 --------------------------
 */

/////////////////////////// GLOBALS ////////////////////////////
import geomerative.*;
import processing.pdf.*;
boolean SAVE_PDF = false; 

RFont font;
RPoint[] myPoints;
String myText = "A"; 
String fontFile = "FuturaModuleProces2.ttf"; // changer la fonte ici [ format .ttf ]

float step = 3;
float colorRange = 0;
float colorStart = 0;
float colorStep = 0;

int fontSize = 300;

/////////////////////////// SETUP ////////////////////////////
void setup() {
  size(620, 620);
  background(255);
  smooth();
  RG.init(this);
  font = new RFont(fontFile, fontSize, CENTER);
}

/////////////////////////// DRAW ////////////////////////////
void draw() {
  if (SAVE_PDF)beginRecord(PDF, "TR_TYPE_###.pdf");
  background(255);
  noStroke();
  translate(width/2, height/1.4);
  RCommand.setSegmentLength(step);
  RCommand.setSegmentator(RCommand.UNIFORMLENGTH);

  RGroup myGoup = font.toGroup(myText);
  myPoints = myGoup.getPoints();
  float mFreq = map(mouseX, 0, width, 0.001, 0.1);
  float mAmp = map(mouseY, 0, height, 1, 300);
  if (myText.length()>0) {
    for (int i=0; i<myPoints.length; i++) {
      float dia = sin(i*mFreq) * mAmp;
      fill(0);
      ellipse(myPoints[i].x, myPoints[i].y, dia, dia);
    }
  }

  if (SAVE_PDF) {
    endRecord();
    SAVE_PDF = !SAVE_PDF;
  }
}

/////////////////////////// FUNCTIONS ////////////////////////////
void keyPressed() {

  if (keyCode == BACKSPACE) {
    if (myText.length() > 0) {
      myText = myText.substring(0, myText.length()-1);
    }
  } else if (keyCode == DELETE) {
    myText = " ";
  } else if (keyCode != ENTER && key != '-' && keyCode != ALT && keyCode != RIGHT && keyCode != LEFT && keyCode != CONTROL  && keyCode != SHIFT) {
    fill(255);
    myText = myText + key;
  }

  if (keyCode == CONTROL) {
    SAVE_PDF = !SAVE_PDF;
  }
}
